#include "simpledeskapplication.h"
#include <QDebug>
#include <QDir>

simpleDeskApplication::simpleDeskApplication(int &argc, char **argv) : QApplication(argc, argv)
{
    qputenv("XDG_CURRENT_DESKTOP", "UKUI");

    desktop_paths << "/usr/share/ukui/ukui-session-manager/simpledesk";

    const XdgDesktopFileList all_file_list = XdgAutoStart::desktopFileList(desktop_paths,true);
    qDebug() << all_file_list.count();

    for (XdgDesktopFileList::const_iterator i = all_file_list.constBegin(); i != all_file_list.constEnd(); ++i) {
        startProcess(*i, true);
    }
}

simpleDeskApplication::~simpleDeskApplication()
{}


void simpleDeskApplication::startProcess(const XdgDesktopFile &file, bool required)
{
    QStringList args = file.expandExecString();
    if (args.isEmpty()) {
        qWarning() << "Wrong desktop file: " << file.fileName();
        return;
    }

    QString name = QFileInfo(file.fileName()).fileName();
    if (!mNameMap.contains(name)) {
        UkuiModule *proc = new UkuiModule(file, this);
        //connect(proc, &UkuiModule::moduleStateChanged, this, &ModuleManager::moduleStateChanged);
        proc->startUKUIModule();

        mNameMap[name] = proc;

//        if (required || autoRestart(file)) {
//            connect(proc, SIGNAL(finished(int, QProcess::ExitStatus)),
//                    this, SLOT(restartModules(int, QProcess::ExitStatus)));
//        }
    }
}
